<template>
    <form @submit.prevent="onSubmit" class="space-y-4">
        <div class="form-control">
            <label class="flex flex-col" for="course_category_id">
                <div>Môn học <span class="text-red-500">*</span></div>
                <select
                    v-model="data.course_category_id"
                    id="course_category_id"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2.5"
                    :class="{ 'border-red-400': dataErrors.course_category_id }"
                >
                    <option disabled value="">Chọn môn học</option>
                    <option
                        :key="category.id"
                        v-for="category in SELECT_OPTION_COURSE_CATEGORY"
                        :value="category.id"
                    >
                        {{ category.text }}
                    </option>
                </select>
            </label>
            <div
                v-if="dataErrors.course_category_id"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.course_category_id }}
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col">
                <div class="mb-1">
                    Nội dung câu hỏi <span class="text-red-500">*</span>
                </div>
                <!-- <QuillEditor
                    v-model:content="data.name"
                    classInput="quiz"
                    height="150"
                /> -->
                <input
                    v-model.number="data.name"
                    id="name"
                    type="text"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                    :class="{ 'border-red-400': dataErrors.name }"
                    placeholder="Nhập nội dung vào đây..."
                />
            </label>
            <div
                v-if="dataErrors.name"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.name }}
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="mark">
                <div>Điểm số <span class="text-red-500">*</span></div>
                <input
                    v-model.number="data.mark"
                    id="mark"
                    type="number"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                    :class="{ 'border-red-400': dataErrors.mark }"
                    placeholder="Số nguyên..."
                />
            </label>
            <div
                v-if="dataErrors.mark"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.mark }}
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="type_question">
                <div>Loại câu hỏi <span class="text-red-500">*</span></div>
                <select
                    v-model="data.type_question"
                    id="type_question"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2.5"
                    :class="{ 'border-red-400': dataErrors.type_question }"
                >
                    <option disabled value="">Chọn loại câu hỏi</option>
                    <option
                        :key="type.id"
                        v-for="type in SELECT_TYPE_QUIZ"
                        :value="type.id"
                    >
                        {{ type.text }}
                    </option>
                </select>
            </label>
            <div
                v-if="dataErrors.type_question"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.type_question }}
            </div>
        </div>

        <div class="form-control border">
            <div class="flex border-b">
                <div class="w-36 p-3">
                    Đáp án đúng <span class="text-red-500">*</span>
                </div>
                <div class="p-3 border-l">
                    Nội dung đáp án <span class="text-red-500">*</span>
                </div>
            </div>

            <template v-if="data.type_question === TYPE_QUIZ_TRUE_FALSE_ANSWER">
                <TrueFalseAnswerQuiz v-model:answers="data.answers" />
            </template>
            <template
                v-else-if="data.type_question === TYPE_QUIZ_MULTI_RIGHT_ANSWER"
            >
                <ListAnswerQuiz
                    v-model:answers="data.answers"
                    :errors="dataErrors.answers"
                    isMultiChoose
                />
            </template>
            <template v-else>
                <ListAnswerQuiz
                    v-model:answers="data.answers"
                    :errors="dataErrors.answers"
                />
            </template>
        </div>

        <div class="form-control flex items-center gap-3">
            <BasicButton type="submit">
                {{ isUpdate ? "Cập nhật" : "Tạo" }}
            </BasicButton>
            <LinkButton
                nameRoute="teacher-quiz"
                classCustom="bg-color-danger hover:shadow-hover-danger"
            >
                Hủy
            </LinkButton>
        </div>
    </form>
</template>

<script>
import { reactive, ref, watch } from "vue";
import { useRouter } from "vue-router";
import { createToast } from "mosha-vue-toastify";
import {
    SELECT_OPTION_COURSE_CATEGORY,
    QUIZ_NOT_CHECKED,
    TYPE_QUIZ_MULTI_RIGHT_ANSWER,
    TYPE_QUIZ_TRUE_FALSE_ANSWER,
    SELECT_TYPE_QUIZ
} from "@/constants";

import useCreateQuiz from "@/hooks/quiz/useCreateQuiz";
import useUpdateQuiz from "@/hooks/quiz/useUpdateQuiz";

// import QuillEditor from "@/components/quill-editor/QuillEditorVue3.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import LinkButton from "@/components/button/LinkButton.vue";
import TrueFalseAnswerQuiz from "@/components/quiz/TrueFalseAnswerQuizForm.vue";
import ListAnswerQuiz from "@/components/quiz/ListAnswerQuizForm.vue";

export default {
    components: {
        // QuillEditor,
        BasicButton,
        LinkButton,
        TrueFalseAnswerQuiz,
        ListAnswerQuiz
    },
    props: {
        quiz: {
            type: Object
        }
    },
    setup(props) {
        const router = useRouter();
        const isUpdate = ref(props.quiz ? true : false);
        const { errorResponse, onCreateQuiz } = useCreateQuiz();
        const { errorResponseUpdate, onUpdateQuiz } = useUpdateQuiz();

        const data = reactive({
            name: props.quiz ? (props.quiz.name ? props.quiz.name : "") : "",
            course_category_id: props.quiz ? props.quiz.course_category_id : "",
            type_question: props.quiz ? props.quiz.type_question : "",
            answers: props.quiz
                ? props.quiz.answers
                    ? props.quiz.answers
                    : []
                : [],
            mark: props.quiz ? props.quiz.mark : ""
        });

        const dataErrors = reactive({
            name: null,
            course_category_id: null,
            type_question: null,
            answers: [],
            mark: null
        });

        watch(
            () => data.type_question,
            (newValue, oldValue) => {
                if (oldValue === TYPE_QUIZ_TRUE_FALSE_ANSWER) {
                    data.answers = [];
                    for (let i = 0; i < 4; i++) {
                        data.answers.push({
                            key: "",
                            right: QUIZ_NOT_CHECKED
                        });
                    }
                } else {
                    // reset checked when choose one/multi answer
                    data.answers = data.answers.map(answer => {
                        return { ...answer, right: QUIZ_NOT_CHECKED };
                    });
                }
            }
        );

        async function onSubmit() {
            dataErrors.name = null;
            dataErrors.course_category_id = null;
            dataErrors.type_question = null;
            dataErrors.mark = null;

            let input_valid = true;
            // check empty input
            if (
                !data.name ||
                data.course_category_id === "" ||
                data.type_question === "" ||
                !data.mark
            ) {
                input_valid = false;
                if (!data.name)
                    dataErrors.name = "Bạn chưa nhập nội dung câu hỏi";
                if (data.course_category_id === "")
                    dataErrors.course_category_id = "Bạn chưa chọn môn học";
                if (data.type_question === "")
                    dataErrors.type_question = "Bạn chưa chọn loại câu hỏi";
                if (!data.mark)
                    dataErrors.mark = "Bạn chưa nhập điểm của câu hỏi này";
            }

            // validate answer
            let answerNotChecked = true;
            data.answers.forEach((answer, index) => {
                if (!answer.key || answer.key == "<p><br></p>") {
                    input_valid = false;
                    if (dataErrors.answers[index]) {
                        dataErrors.answers[index] =
                            "Bạn chưa nhập nội dung đáp án này";
                    } else {
                        dataErrors.answers.push(
                            "Bạn chưa nhập nội dung đáp án này"
                        );
                    }
                } else {
                    if (dataErrors.answers[index]) {
                        dataErrors.answers[index] = null;
                    } else {
                        dataErrors.answers.push(null);
                    }
                }

                if (answer.right) {
                    answerNotChecked = false;
                }
            });

            if (answerNotChecked) {
                input_valid = false;
                createToast("Vui lòng chọn đáp án đúng cho câu hỏi này", {
                    showIcon: true,
                    type: "warning"
                });
            }

            // check input valid and submit form
            if (input_valid) {
                // show loading
                document.getElementById("full-page-loading").style.display =
                    "block";

                if (isUpdate.value) {
                    await onUpdateQuiz(props.quiz.id, {
                        ...data,
                        answers: JSON.stringify(data.answers)
                    });
                } else {
                    await onCreateQuiz({
                        ...data,
                        answers: JSON.stringify(data.answers)
                    });
                }

                // hide loading
                document.getElementById("full-page-loading").style.display =
                    "none";

                // check error from server
                if (errorResponse.value || errorResponseUpdate.value) {
                    if (errorResponseUpdate.value) {
                        errorResponse.value = errorResponseUpdate.value;
                    }
                    if (
                        errorResponse.value.name &&
                        errorResponse.value.name.length
                    ) {
                        dataErrors.name = errorResponse.value.name[0];
                    }
                    if (
                        errorResponse.value.course_category_id &&
                        errorResponse.value.course_category_id.length
                    ) {
                        dataErrors.course_category_id =
                            errorResponse.value.course_category_id[0];
                    }
                    if (
                        errorResponse.value.type_question &&
                        errorResponse.value.type_question.length
                    ) {
                        dataErrors.type_question =
                            errorResponse.value.type_question[0];
                    }
                    if (
                        errorResponse.value.answers &&
                        errorResponse.value.answers.length
                    ) {
                        dataErrors.answers = errorResponse.value.answers[0];
                    }
                    if (
                        errorResponse.value.mark &&
                        errorResponse.value.mark.length
                    ) {
                        dataErrors.mark = errorResponse.value.mark[0];
                    }
                } else {
                    createToast(
                        isUpdate.value
                            ? "Cập nhật câu hỏi thành công"
                            : "Tạo câu hỏi thành công",
                        {
                            showIcon: true,
                            type: "success"
                        }
                    );
                    router.push({ name: "teacher-quiz", params: {} });
                }
            }
        }

        return {
            SELECT_OPTION_COURSE_CATEGORY,
            TYPE_QUIZ_MULTI_RIGHT_ANSWER,
            TYPE_QUIZ_TRUE_FALSE_ANSWER,
            SELECT_TYPE_QUIZ,
            isUpdate,
            data,
            dataErrors,
            onSubmit
        };
    }
};
</script>
